package net.awired.ajsl.persistence.dao.implementation;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.BeanNameAware;
import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.annotation.AutowiredAnnotationBeanPostProcessor;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

//@Component
public class TTestFactoryBean implements FactoryBean<GenericsDAOImpl>, ApplicationContextAware, BeanNameAware {

    private AutowiredAnnotationBeanPostProcessor annotationBeanPostProcessor;
    private String                               name;

    public TTestFactoryBean() {
        System.out.println();
    }

    public GenericsDAOImpl getObject() throws Exception {
        GenericsDAOImpl result = new GenericsDAOImpl(null, null);
        annotationBeanPostProcessor.processInjection(result);

        // not used this
        // annotationBeanPostProcessor.postProcessAfterInstantiation(result, name);
        return result;
    }

    public Class getObjectType() {
        return GenericsDAOImpl.class;
    }

    public boolean isSingleton() {
        return false;
    }

    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        annotationBeanPostProcessor = (AutowiredAnnotationBeanPostProcessor) applicationContext.getBeansOfType(
                AutowiredAnnotationBeanPostProcessor.class).values().iterator().next();
    }

    public void setBeanName(String name) {
        this.name = name;
    }
}
