package net.awired.ajsl.persistence.dao.interfaces.abstracts;

import java.io.Serializable;
import net.awired.ajsl.persistence.entity.interfaces.abstracts.IdEntity;
import org.springframework.dao.DataAccessException;

public interface CreateDAO<ENTITY extends IdEntity<KEY_TYPE>, KEY_TYPE extends Serializable> {

    void persist(ENTITY transientInstance) throws DataAccessException;

    void save(ENTITY transientInstance) throws DataAccessException;

    void update(ENTITY transientInstance) throws DataAccessException;

}
